'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var highlight = require('@lezer/highlight');
var language = require('@codemirror/language');

const highlighting = highlight.styleTags({
    String: highlight.tags.string,
    Number: highlight.tags.number,
    Boolean: highlight.tags.bool,
    Nil: highlight.tags.null,
    PropertyName: highlight.tags.propertyName,
    TemplateString: highlight.tags.string,
    "extern var const": highlight.tags.definitionKeyword,
    "include break continue enum class switch while for fork return": highlight.tags.keyword,
    "new": highlight.tags.special(highlight.tags.keyword),
    "List Map Set": highlight.tags.list,
    ",": highlight.tags.separator,
    "[ ]": highlight.tags.bracket,
    "{ }": highlight.tags.brace,
    "( ) |": highlight.tags.paren,
    '< <= > >= == "!="': highlight.tags.compareOperator,
    "if else and or": highlight.tags.logicOperator,
    '+ - "/" "*" "+=" "-=" "/=" "*="': highlight.tags.arithmeticOperator,
    Equal: highlight.tags.definitionOperator,
    DotDot: highlight.tags.arithmeticOperator,
    Comment: highlight.tags.lineComment,
    Choice: highlight.tags.controlOperator,
    BackUp: highlight.tags.controlOperator,
    BoughName: highlight.tags.controlKeyword,
    Speaker: highlight.tags.name,
    Tag: highlight.tags.tagName,
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_identifier = {__proto__:null,include:8, and:30, or:32, if:70, else:72, new:80, List:92, Map:96, Set:104, fork:128, extern:138, var:140, const:142, for:146, while:150, switch:156, class:162, enum:166, return:170, break:174, continue:178};
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "=^QYQPOOO#]QPO'#EeO&eQPO'#CnO&eQPO'#CpOOQO'#Cz'#CzO'cQPO'#CxO'|QPO'#EuOOQO'#Eu'#EuOOQO'#Ei'#EiO+TOWO'#CaO+`QQO'#DeO+eQQO'#DhO+jQSO'#DjO+rQPO'#DpOOQO'#Ee'#EeOOQO'#EY'#EYQYQPOOO&eQPO'#DzO'fQPO'#DTO+zQPO'#DZO,PQPO'#D]O,UQPO'#DaO#WQPO'#C_O,ZQPO'#DmO'fQPO'#DrO,eQPO'#DrO&eQPO'#DvO&eQPO'#DxO&eQPO'#D{O'fQPO'#EOO'fQPO'#EQOOQO'#ES'#ESOOQO'#EU'#EUOOQO'#EW'#EWOOQO'#Ce'#CeOOQO'#Cm'#CmO&eQPO,59OO&eQPO,59_O,mQPO,59bOOQO'#Cj'#CjO,tQPO,59YO&eQPO'#DOO1TQPO,59[O1[QPO'#EpO1gQPO,59dO3mQPO,59dO3rQPO,59iO&eQPO,59mO3yQPO,59mO&eQPO'#CbOOOO'#EZ'#EZO4OOWO,58{OOQO,58{,58{O4ZQPO,5:POOQO,5:S,5:SO#WQPO,5:UO4bQPO,5:UO4ZQPO,5:[O#WQPO,5:[OOQO-E8W-E8WO4gQPO,5:fO7fQPO,59oO7kQPO,59uO7rQPO,59wO7yQPO,59{OOQO,58y,58yO8QQPO'#ErOOQO'#Er'#ErOOQO,5:X,5:XO4ZQPO,5:XO8XQPO'#DROOQO,5:^,5:^O'fQPO,5:^O8jQPO,5:bO4gQPO,5:dO8qQPO,5:gO8xQPO,5:jO8}QPO,5:lO9SQPO1G.jO;nQPO1G.yO;uQPO1G.|O&eQPO1G/iO@TQPO,59jOOQO1G.v1G.vO'fQPO'#E[O@[QPO,5;[OOQO1G/O1G/OO1gQPO1G/OO@gQPO'#EsOOQO1G/T1G/TO@tQPO1G/TOCxQPO1G/XO&eQPO1G/XOD`QPO,58|OOOO-E8X-E8XOOQO1G.g1G.gOOQO1G/k1G/kODgQPO1G/pO#WQPO1G/pOOQO1G/v1G/vO4ZQPO1G/vOG{QPO'#CeOHyQPO1G/UOMeQPO1G0QOMlQPO1G/ZOOQO1G/a1G/aOMtQPO1G/aOMyQPO'#D_ONQQPO'#EvOOQO1G/c1G/cONYQPO1G/cOOQO1G/g1G/gON_QPO1G/gOOQO,5;^,5;^ONdQPO,5;^OOQO1G/s1G/sOOQO1G/x1G/xO'fQPO1G/|OOQO1G0O1G0OONkQPO1G0RONrQPO1G0UONwQPO1G0WOOQO7+$e7+$eON|QPO7+%TO!#hQPO1G/UOOQO,5:v,5:vOOQO-E8Y-E8YOOQO7+$j7+$jO&eQPO'#E]O!#oQPO,5;_OOQO7+$o7+$oO!&yQPO7+$sOOOO'#Dd'#DdOOOO1G.h1G.hOOQO'#E`'#E`O!'aQPO7+%[O!'aQPO7+%[OOQO7+%b7+%bO&eQPO7+$pO4ZQPO7+%lO!*uQPO'#DVO!*zQPO'#EtOOQO7+$u7+$uO!+SQPO7+$uOOQO7+${7+${O&eQPO,59yO&eQPO'#E_O!+XQPO,5;bOOQO7+$}7+$}OOQO7+%R7+%ROOQO1G0x1G0xO!+aQPO7+%hO!+fQPO'#D}O!+mQPO'#ExO!+uQPO'#D}O!+zQPO7+%mO'fQPO7+%pO'fQPO7+%rO!,PQPO,5:wOOQO-E8Z-E8ZOOQO-E8^-E8^O!,^QPO<<HvO!/rQPO<<H[OOQO<<IW<<IWO&eQPO,59qO'fQPO'#E^O!3TQPO,5;`OOQO<<Ha<<HaO!3]QPO1G/eOOQO,5:y,5:yOOQO-E8]-E8]O4ZQPO<<ISO4ZQPO,5:iONkQPO'#EaO!3gQPO,5;dOOQO<<IX<<IXO!3oQPO<<I[O!3tQPO<<I^O!3yQPO1G/]OOQO,5:x,5:xOOQO-E8[-E8[OOQOAN>nAN>nOOQO1G0T1G0TOOQO,5:{,5:{OOQO-E8_-E8_OOQOAN>vAN>vOOQOAN>xAN>xO!4TQPO'#EeO!4eQPO'#DmO1gQPO,5:PO1gQPO,5:[O!4lQPO,5:fO1gQPO,5:XO!4lQPO,5:dO!5{QPO1G/XO1gQPO1G/vO!6YQPO1G/UO!8tQPO7+$sO1gQPO7+%lO1gQPO<<ISO!9RQQO'#DeO!9WQPO'#DpO&eQPO'#DzO&eQPO'#DxO&eQPO,59mO#WQPO,5:[O'kQPO'#DRO'fQPO,5:^O&eQPO1G/XO!9`QPO1G0QO!:iQPO7+%hO'fQPO'#DrO!:nQPO'#DrO!:vQPO,59mO'fQPO1G/|O!:{QPO,5:bO&eQPO'#Dv",
  stateData: "!;[~O#WOSPOS~OSfO]QOcQOeROmTOsaOxbOzVO{VO|VO!OcO!QdO!S[O!UeO!YYO!]ZO!bgO!e]O!giO!hhO!ihO!kjO!mkO!plO!smO!unO!woO!ypO!{qO#YSO#ZXO~OYrOZrO[rO]rO_wO`wOhuOkvO#^sO#_sO#`sO#asO#bsO#csOS#XXc#XXe#XXm#XXs#XXx#XXz#XX{#XX|#XX!O#XX!Q#XX!S#XX!U#XX!Y#XX!]#XX!b#XX!e#XX!g#XX!h#XX!i#XX!k#XX!m#XX!p#XX!s#XX!u#XX!w#XX!y#XX!{#XX#U#XX#Y#XX#Z#XXp#XXt#XX#e#XX~O]QOcQOeROmTOsyOxbOzVO{VO|VO!OcO!QdO!UeO#YSO#ZXO~Om|O#YSO~OY!QOZ!QO[!QO]!QOv!PO~Oe!OOS#iX_#iX`#iXc#iXh#iXk#iXm#iXs#iXx#iXz#iX{#iX|#iX!O#iX!Q#iX!S#iX!U#iX!Y#iX!]#iX!b#iX!e#iX!g#iX!h#iX!i#iX!k#iX!m#iX!p#iX!s#iX!u#iX!w#iX!y#iX!{#iX#U#iX#Y#iX#Z#iX#^#iX#_#iX#`#iX#a#iX#b#iX#c#iXf#iXo#iXi#iX#e#iXp#iXt#iX~P'kOV!RO#[!SO#k!UO~O!Z!VO~O!Z!WO~O!S!XO!_!YO~OY![O#ZXO~Oo!`O~Oo!aO~Oo!bO~Oo!dO!c!gO~PYO!h!jO!i!jO~Ok!sO~P&eOhuOSbaYbaZba[ba]ba_ba`bacbaebakbambasbaxbazba{ba|ba!Oba!Qba!Sba!Uba!Yba!]ba!bba!eba!gba!hba!iba!kba!mba!pba!sba!uba!wba!yba!{ba#Uba#Yba#Zba#^ba#_ba#`ba#aba#bba#cbafbaobaiba#ebapbatba~OYrOZrO[rO]rO_wO`wOhuOkvO#^sO#_sO#`sO#asO#bsO#csO~Of!uO~P0VO#e!vOm#dXp#dX~OSfO]QOcQOeROmTOo!dOs%bOxbOzVO{VO|VO!OcO!QdO!S[O!UeO!Y%`O!]ZO!b%SO!e%aO!g%lO!h%kO!i%kO!k%pO!m%cO!plO!smO!unO!woO!ypO!{qO#YSO#ZXO~Om!yO~Of!{O~P&eOv#OO~OV!RO#[!SO#k#RO~Oo!dO~PYO!S#UO~OSfOYrOZrO[rO]#XO_wO`wOcQOeROhuOkvOmTOo!dOsaOxbOzVO{VO|VO!OcO!QdO!S[O!UeO!YYO!]ZO!bgO!e]O!giO!hhO!ihO!kjO!mkO!plO!smO!unO!woO!ypO!{qO#YSO#ZXO#^sO#_sO#`sO#asO#bsO#csO~Oo#[O~Op#]O~P&eOp#aO~P&eOp#cO~P&eOp#eO~PYOY%mOZ%mO[%mO]%mOv%dO~Om#iO~P0VOo#kO~P0VOv#lO~Ov#mO~OSWicWieWikWimWisWixWizWi{Wi|Wi!OWi!QWi!SWi!UWi!YWi!]Wi!bWi!eWi!gWi!hWi!iWi!kWi!mWi!pWi!sWi!uWi!wWi!yWi!{Wi#UWi#YWi#ZWifWioWiiWi#eWipWitWi~P0VOi#nO~P0VOSjicjiejikjimjisjixjizji{ji|ji!Oji!Qji!Sji!Uji!Yji!]ji!bji!eji!gji!hji!iji!kji!mji!pji!sji!uji!wji!yji!{ji#Uji#Yji#Zjifjiojiiji#ejipjitji~P0VOYrOZrO[rO]#XO_wO`wOcQOeROhuOkvOmTOxbOzVO{VO|VO!OcO!QdO!UeO#YSO#ZXO#^sO#_sO#`sO#asO#bsO#csO~OsyO~P>aO#e!vOm#dap#da~O#e#tOf#gXp#gX~P0VOf#vO~OYrOZrO[rO]rOhuO#^sO#_sO#`sO#asO#bsO#csOSuicuieuimuisuixuizui{ui|ui!Oui!Qui!Sui!Uui!Yui!]ui!bui!eui!gui!hui!iui!kui!mui!pui!sui!uui!wui!yui!{ui#Uui#Yui#Zui#euipuitui~O_ui`uikuifuiouiiui~P@yOp#xO~P0VO!`#zOS!^i]!^ic!^ie!^im!^is!^ix!^iz!^i{!^i|!^i!O!^i!Q!^i!S!^i!U!^i!Y!^i!]!^i!b!^i!e!^i!g!^i!h!^i!i!^i!k!^i!m!^i!p!^i!s!^i!u!^i!w!^i!y!^i!{!^i#U!^i#Y!^i#Z!^iY!^iZ!^i[!^i_!^i`!^ih!^ik!^i#^!^i#_!^i#`!^i#a!^i#b!^i#c!^it!^ip!^if!^io!^ii!^i#e!^i~O]QOcQOeXXmXXsXXxXXzXX{XX|XX!OXX!QXX!UXX#YXX#ZXX~Ot$OOS#XXc#XXe#XXm#XXs#XXx#XXz#XX{#XX|#XX!O#XX!Q#XX!S#XX!U#XX!Y#XX!]#XX!b#XX!e#XX!g#XX!h#XX!i#XX!k#XX!m#XX!p#XX!s#XX!u#XX!w#XX!y#XX!{#XX#U#XX#Y#XX#Z#XXp#XX#e#XX~P0VOS!ni]!nic!nie!nim!nis!nix!niz!ni{!ni|!ni!O!ni!Q!ni!S!ni!U!ni!Y!ni!]!ni!b!ni!e!ni!g!ni!h!ni!i!ni!k!ni!m!ni!p!ni!s!ni!u!ni!w!ni!y!ni!{!ni#U!ni#Y!ni#Z!nip!ni#e!ni~Ot$PO~PKXOp$SO#YSO~Op$UO~O!S$VO~P0VO#e$WOp#jX~Op$YO~Op$ZO~Op$[O~PYOt$`O~P&eOo$bO~Oo$cO~OS!Vqc!Vqe!Vqk!Vqm!Vqs!Vqx!Vqz!Vq{!Vq|!Vq!O!Vq!Q!Vq!S!Vq!U!Vq!Y!Vq!]!Vq!b!Vq!e!Vq!g!Vq!h!Vq!i!Vq!k!Vq!m!Vq!p!Vq!s!Vq!u!Vq!w!Vq!y!Vq!{!Vq#U!Vq#Y!Vq#Z!Vqf!Vqo!Vqi!Vq#e!Vqp!Vqt!Vq~P0VOt$OO~P0VO#e#tOf#gap#ga~OYrOZrO[rO]rOhuO#^sO#_sO#`sO#asO#bsO#csOSuqcuqeuqmuqsuqxuqzuq{uq|uq!Ouq!Quq!Suq!Uuq!Yuq!]uq!buq!euq!guq!huq!iuq!kuq!muq!puq!suq!uuq!wuq!yuq!{uq#Uuq#Yuq#Zuq#euqpuqtuq~O_uq`uqkuqfuqouqiuq~P!#zO!`#zOS!^q]!^qc!^qe!^qm!^qs!^qx!^qz!^q{!^q|!^q!O!^q!Q!^q!S!^q!U!^q!Y!^q!]!^q!b!^q!e!^q!g!^q!h!^q!i!^q!k!^q!m!^q!p!^q!s!^q!u!^q!w!^q!y!^q!{!^q#U!^q#Y!^q#Z!^qY!^qZ!^q[!^q_!^q`!^qh!^qk!^q#^!^q#_!^q#`!^q#a!^q#b!^q#c!^qt!^qp!^qf!^qo!^qi!^q#e!^q~Ov$jO~O#e$kOp#hX~Op$mO~O#e$WOp#ja~Om$qO~O!S$rO~P0VO#e$sOp#lX~O!S$rO~Op$uO~Of#Pa#e#Pap#Pa~P0VO!`#zOS!^y]!^yc!^ye!^ym!^ys!^yx!^yz!^y{!^y|!^y!O!^y!Q!^y!S!^y!U!^y!Y!^y!]!^y!b!^y!e!^y!g!^y!h!^y!i!^y!k!^y!m!^y!p!^y!s!^y!u!^y!w!^y!y!^y!{!^y#U!^y#Y!^y#Z!^yY!^yZ!^y[!^y_!^y`!^yh!^yk!^y#^!^y#_!^y#`!^y#a!^y#b!^y#c!^yt!^yp!^yf!^yo!^yi!^y#e!^y~OhuOSryYryZry[ry]ry_ry`rycryerykrymrysryxryzry{ry|ry!Ory!Qry!Sry!Ury!Yry!]ry!bry!ery!gry!hry!iry!kry!mry!pry!sry!ury!wry!yry!{ry#Ury#Yry#Zry#^ry#_ry#`ry#ary#bry#cryfryoryiry#eryprytry~O#e$kOp#ha~Op!Ri#e!Ri~P0VO#e$sOp#la~Op%PO~Op%QO~Opyi#eyi~P0VOk#XXf#XXo#XXi#XX~P#]O!c%WO~P1gOSfOo!dOs%bO!S[O!Y%`O!]ZO!b%SO!e%aO!g%lO!h%kO!i%kO!k%pO!m%cO!plO!smO!unO!woO!ypO!{qO~P>aO_wO`wOkvO~P@yOt$OOS#XXc#XXe#XXk#XXm#XXs#XXx#XXz#XX{#XX|#XX!O#XX!Q#XX!S#XX!U#XX!Y#XX!]#XX!b#XX!e#XX!g#XX!h#XX!i#XX!k#XX!m#XX!p#XX!s#XX!u#XX!w#XX!y#XX!{#XX#U#XX#Y#XX#Z#XXf#XXo#XXi#XX#e#XXp#XX~P0VO_wO`wOkvO~P!#zO!Z%TO~OY%eO#ZXO~Ot%^OY!niZ!ni[!ni_!ni`!nih!nik!ni#^!ni#_!ni#`!ni#a!ni#b!ni#c!nif!nio!nii!ni~PKXOm%_O~O!h%gO!i%gO~Ov%hO~Om%nO~P0VOz{PZ!_#Y#W~",
  goto: "6c#mPPP#nP$Z%|P&Q'_PPPP(OPP'_&QP(mPP&QPP&QP(mP)yPP(m(mPP+zP(mP-`PPP-gP-gP.sP-gP.y0W#nPP#nP#nPP#nPP#nP#nPPP#nP#nP#n#nP0Z#nP#nP#nP#nP#nP0a0k0q0w0}1T1Z1ePPP1kPPP2YPPPPPP4uP4{5|6V&Q6]P6`!T^O`g|!V!Z!^!d!g!l!y#W#f$P$q$r%S%T%U%V%W%X%Z%^%_#dVOQR`agjkltuvy|!O!P!R!V!Z!^!`!a!b!d!g!l!s!t!y#O#W#f#k#t$O$P$V$W$j$q$r$s%S%T%U%V%W%X%Z%^%_%b%c%d%h%pQ!Z]Q!cfQ#T!XQ#W![Q#|#UQ%U%aR%Z%eT!SX!T#gWOQR`agjkltuvy|!O!P!R!V!Z!^!`!a!b!d!g!l!s!t!y#O#W#X#f#k#t$O$P$V$W$j$q$r$s%S%T%U%V%W%X%Z%^%_%b%c%d%h%p!]tPz!^!k!l!m!p!q!r!t!z!}#P#Y#_#o#p#w$^$d$n$x%R%V%X%Y%[%]%o!XtPz!^!k!l!m!p!q!r!t!z#P#Y#_#o#p$^$d$n$x%R%V%X%Y%[%]%o#eWOQR`agjkltuvy|!O!P!R!V!Z!^!`!a!b!d!g!l!s!t!y#O#W#f#k#t$O$P$V$W$j$q$r$s%S%T%U%V%W%X%Z%^%_%b%c%d%h%p#dUOQR`agjkltuvy|!O!P!R!V!Z!^!`!a!b!d!g!l!s!t!y#O#W#f#k#t$O$P$V$W$j$q$r$s%S%T%U%V%W%X%Z%^%_%b%c%d%h%pS{T$cQ!_bS!hh!jQ!nmQ!onQ#q!vU$Q#[$b$kQ$]#iS%f%g%kR%j%n#dWOQR`agjkltuvy|!O!P!R!V!Z!^!`!a!b!d!g!l!s!t!y#O#W#f#k#t$O$P$V$W$j$q$r$s%S%T%U%V%W%X%Z%^%_%b%c%d%h%pS!ih%kT#h!j%gS$R#[$bR$y$k#eVOQR`agjkltuvy|!O!P!R!V!Z!^!`!a!b!d!g!l!s!t!y#O#W#f#k#t$O$P$V$W$j$q$r$s%S%T%U%V%W%X%Z%^%_%b%c%d%h%pQ#`!aR$o$W#gVOQR`agjkltuvy|!O!P!R!V!Z!^!`!a!b!d!g!l!s!t!y#O#W#X#f#k#t$O$P$V$W$j$q$r$s%S%T%U%V%W%X%Z%^%_%b%c%d%h%pR#y#PQ$_#kR$}$sQ`OS!]`#fR#f!dQ!TXR#Q!TQ!w{R#r!wQ#u!zR$e#uQ$l$RR$z$lQ$X#`R$p$XQ#{#TS$f#{$gR$g#|Q$t$_R%O$tW_O`!d#f{!eg|!V!Z!^!g!l!y#W$P$q$r%S%T%U%V%W%X%Z%^%_jPO`g!V!Z!d!g!l#W#f$P$q$rSxQ#XQzRQ!^aQ!kjQ!lkQ!mlQ!ptQ!quQ!rvQ!tyU!z!O!`!bQ!}!PQ#P!RQ#Y!^S#_!a$WQ#o!sQ#p!tQ#w#OS$^#k$sQ$d#tQ$h$OQ$n$VQ$x$jd%R|!y%S%T%U%W%X%Z%^%_Q%V%bQ%X%cQ%Y%dQ%[%VQ%]%hR%o%pQ}TR$w$cS!fg%SQ!x|S#S!V%TS#V!Z%UQ#Z!^S#g!g%WS#j!l%XQ#s!yS#}#W%ZS$i$P%^S${$q%_Q$|$rR%i%VQ!|!OQ#^!`R#d!bQ$T#[R$v$bR#b!aR$a#k",
  nodeNames: "⚠ Comment Program IncludeStatement include TemplateString Interpolation InterpolationStart Binary ArithOp * / + - LogicOp and or CompareOp Unary ! Group ( ) Index [ ] Member . Function | Identifier { } Call If if else Assign Equal Instance new Field Boolean Nil Number List List Map Map MapPair : Set Set Range InterpolationEnd BoughStatement Bough BoughName DivertStatement Jump DialogueStatement Speaker Tag ForkStatement fork BackUp ChoiceStatement Choice VariableStatement extern var const ForStatement for WhileStatement while IfStatement SwitchStatement switch Prong ClassStatement class EnumStatement enum Return return Break break Continue continue",
  maxTerm: 120,
  nodeProps: [
    ["isolate", -3,1,5,6,""],
    ["closedBy", 7,"InterpolationEnd"],
    ["openedBy", 54,"InterpolationStart"]
  ],
  propSources: [highlighting],
  skippedNodes: [0,1],
  repeatNodeCount: 8,
  tokenData: "Ft~R!ROX$[XY$yYZ$yZ]$[]^$y^p$[pq$yqr%drs&nst'Xtu)Sux$[xy*byz*{z{+f{|,P|},j}!O-T!O!P-n!P!Q.X!Q!R.x!R![0h![!]1U!]!^$[!^!_1Z!_!`2e!`!a4|!a!c$[!c!})S!}#O6W#P#Q6q#Q#R7[#R#S)S#S#T$[#T#Y)S#Y#Z7u#Z#b)S#b#c>W#c#h)S#h#iBO#i#o)S#o#pDl#p#qEV#q#rEp#r#sFZ#s$g$[$g;'S)S;'S;=`*[<%lO)SW$aU!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[W$vP;=`<%l$[~%QU!_W#W~O!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y%kWcQ!_WO!P$[!Q![$[!]!_$[!_!`&T!`#O$[#P;'S$[;'S;=`$s<%lO$[Y&[U#_Q!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y&uU#ZQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y'`_!`Q!_WOY'XYZ$[Zs'Xst$[t!P'X!P!Q(_!Q!['X![!](_!]#O'X#O#P(_#P#k'X#k#l$[#l;'S'X;'S;=`(|<%lO'XQ(dU!`QOY(_Zs(_t#k(_#l;'S(_;'S;=`(v<%lO(_Q(yP;=`<%l(_Y)PP;=`<%l'X^)]_!ZS!_W#YQOt$[tu)Su!P$[!Q![)S!]!c$[!c!})S!}#O$[#P#R$[#R#S)S#S#T$[#T#o)S#o$g$[$g;'S)S;'S;=`*[<%lO)S^*_P;=`<%l)SY*iUeQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y+SUfQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y+mUYQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y,WU[Q!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y,qU#eQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y-[U]Q!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y-uUkQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[~.^PZ~!P!Q.a~.fSP~OY.aZ;'S.a;'S;=`.r<%lO.a~.uP;=`<%l.aY/PV|Q!_WO!O$[!O!P/f!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y/kU!_WO!P$[!Q![/}!]#O$[#P;'S$[;'S;=`$s<%lO$[Y0UU|Q!_WO!P$[!Q![/}!]#O$[#P;'S$[;'S;=`$s<%lO$[Y0oV|Q!_WO!O$[!O!P/f!Q![0h!]#O$[#P;'S$[;'S;=`$s<%lO$[~1ZO!S~Y1bW#`Q!_WO!P$[!Q![$[!]!_$[!_!`1z!`#O$[#P;'S$[;'S;=`$s<%lO$[Y2RU#bQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y2lXvQ!_WO!P$[!Q![$[!]!_$[!_!`3X!`!a4c!a#O$[#P;'S$[;'S;=`$s<%lO$[Y3`W#^Q!_WO!P$[!Q![$[!]!_$[!_!`3x!`#O$[#P;'S$[;'S;=`$s<%lO$[Y4PU!YQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y4jU!]Q!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y5TW#aQ!_WO!P$[!Q![$[!]!_$[!_!`5m!`#O$[#P;'S$[;'S;=`$s<%lO$[Y5tU#cQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y6_UhQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y6xUiQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[Y7cU!cQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[^8O`!ZS!_W#YQOt$[tu)Su!P$[!Q![)S!]!c$[!c!})S!}#O$[#P#R$[#R#S)S#S#T$[#T#U9Q#U#o)S#o$g$[$g;'S)S;'S;=`*[<%lO)S^9Za!ZS!_W#YQOt$[tu)Su!P$[!Q![)S!]!c$[!c!})S!}#O$[#P#R$[#R#S)S#S#T$[#T#`)S#`#a:`#a#o)S#o$g$[$g;'S)S;'S;=`*[<%lO)S^:ia!ZS!_W#YQOt$[tu)Su!P$[!Q![)S!]!c$[!c!})S!}#O$[#P#R$[#R#S)S#S#T$[#T#g)S#g#h;n#h#o)S#o$g$[$g;'S)S;'S;=`*[<%lO)S^;wa!ZS!_W#YQOt$[tu)Su!P$[!Q![)S!]!c$[!c!})S!}#O$[#P#R$[#R#S)S#S#T$[#T#X)S#X#Y<|#Y#o)S#o$g$[$g;'S)S;'S;=`*[<%lO)S^=X_!ZSzQ!_W#YQOt$[tu)Su!P$[!Q![)S!]!c$[!c!})S!}#O$[#P#R$[#R#S)S#S#T$[#T#o)S#o$g$[$g;'S)S;'S;=`*[<%lO)S^>aa!ZS!_W#YQOt$[tu)Su!P$[!Q![)S!]!c$[!c!})S!}#O$[#P#R$[#R#S)S#S#T$[#T#])S#]#^?f#^#o)S#o$g$[$g;'S)S;'S;=`*[<%lO)S^?oa!ZS!_W#YQOt$[tu)Su!P$[!Q![)S!]!c$[!c!})S!}#O$[#P#R$[#R#S)S#S#T$[#T#`)S#`#a@t#a#o)S#o$g$[$g;'S)S;'S;=`*[<%lO)S^AP_!ZS{Q!_W#YQOt$[tu)Su!P$[!Q![)S!]!c$[!c!})S!}#O$[#P#R$[#R#S)S#S#T$[#T#o)S#o$g$[$g;'S)S;'S;=`*[<%lO)S^BXa!ZS!_W#YQOt$[tu)Su!P$[!Q![)S!]!c$[!c!})S!}#O$[#P#R$[#R#S)S#S#T$[#T#f)S#f#gC^#g#o)S#o$g$[$g;'S)S;'S;=`*[<%lO)S^Cga!ZS!_W#YQOt$[tu)Su!P$[!Q![)S!]!c$[!c!})S!}#O$[#P#R$[#R#S)S#S#T$[#T#i)S#i#j;n#j#o)S#o$g$[$g;'S)S;'S;=`*[<%lO)SYDsUoQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[YE^UmQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[YEwUpQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[YFbU!eQ!_WO!P$[!Q![$[!]#O$[#P;'S$[;'S;=`$s<%lO$[",
  tokenizers: [1, 2, 3, new lr.LocalTokenGroup("d~RQrsX#o#p^~^O#k~~cOV~~", 19, 104)],
  topRules: {"Program":[0,2]},
  specialized: [{term: 102, get: (value) => spec_identifier[value] || -1}],
  tokenPrec: 3316
});

const topiLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                Application: language.delimitedIndent({ closing: ")", align: false })
            }),
            language.foldNodeProp.add({
                Application: language.foldInside
            }),
            highlighting
        ]
    }),
    languageData: {
        commentTokens: { line: "//" }
    }
});
function topi() {
    return new language.LanguageSupport(topiLanguage);
}

exports.topi = topi;
exports.topiLanguage = topiLanguage;
